component-section
  div(slot='title') 🧮 Algoritmes en complexiteit
  component-section
    div(slot='title') Algoritmes
    p
      | Een
      |
      em.term algoritme
      |
      | is een compleet ‘stappenplan’ om een
      |
      em.term computationele taak
      |
      | (
      em.term probleem
      | ) op te lossen.
      |
      | Het stappenplan is in principe algemeen, bijvoorbeeld wiskundig gedefinieerd en niet in een concrete programmeertaal.
      | De kleinst mogelijke stap in een algoritme heet een
      |
      em.term instructie
      | .
    p
      | Het begrip ‘algoritme’ heeft
      a(href='https://en.wikipedia.org/wiki/Algorithm_characterizations') geen exacte definitie
      | .
      a(href='https://www.quantamagazine.org/computer-scientist-donald-knuth-cant-stop-telling-stories-20200416/') Donald Knuth
      |
      | benoemt vijf criteria voor algoritmes
      cite(data-id='6867189/L2768YLY', data-label='page', data-locator='22-23')
      | : een algoritme …
    ol
      li
        p … stopt altijd na een telbaar aantal instructies (is eindig).
        p
          small
            em.term Finiteness
      li
        p … bevat alleen ondubbelzinnige instructies.
        p
          small
            em.term Definiteness
      li
        p … heeft nul of meer invoer-waarden (data, bijvoorbeeld een getal).
        p
          small
            em.term Input
      li
        p
          | … heeft één of meer uitvoer-waarden, met een duidelijke betekenis en verband met de invoer-waarden.
        p
          small
            em.term Output
      li
        p
          | … is begrijpbaar, zodat je ook werkelijk het probleem ermee kan oplossen.
          | Het bevat dus géén weliswaar ondubbelzinnige, maar onhaalbare stappen, zoals:
          q Vind nu een oplossing voor … (een wiskundig probleem dat nog onopgelost is).
          |
          | 😒
        p
          small
            em.term Effectiveness
    p
      | Een
      |
      em.term standaardalgoritme
      |
      | is in deze course een algoritme dat fundamenteel en basaal is binnen de informatica.
    p
      span.praktijk
      | Algoritmes
      |
      em.term implementeer
      |
      | je in de vorm van broncode in een programmeertaal, om de algoritmes echt uit te kunnen voeren.
      | Er kunnen verschillende licht afwijkende implementaties bestaan van hetzelfde algoritme, zelfs terwijl die in één programmeertaal zijn.
  component-section
    div(slot='title') Waarom je datastructuren en algoritmes leert
    p
      | Vrijwel alle software gebruikt standaarddatastructuren en algoritmes.
      | Als je bijvoorbeeld een route wilt plannen, je contactenlijst wilt bewaren, of je browser gebruiken, ben je al afhankelijk van datastructuren en algoritmes.
    p
      | Algoritmes en datastructuren gebruik je vanzelf, soms misschien indirect als je werkt met bepaalde libraries.
      | De grootte van de data waar je mee werkt heeft vaak grote invloed op de performance efficiency van software
      span.praktijk
      | .
  component-section
    div(slot='title') Algoritmeanalyse
    p
      | Om software zo snel mogelijk te maken, wil je de efficiëntie van algoritmes voor dezelfde computationele taak kunnen vergelijken.
      | Maar … looptijdmetingen zijn erg afhankelijk van toevallige en veranderbare technologische factoren, zoals het toevallige benuttingspercentage van de hardware tijdens de meting, de hardware zelf en de programmeertaalimplementatie. 🤯
    p
      | Analyse van
      |
      em.term computationele complexiteit
      |
      | is een manier om de kern door te dringen van een algoritme, om zo zijn efficiëntie exact te kunnen aangeven.
      | Deze analyse wordt ook
      |
      em.term asymptotische analyse
      | ,
      em.term algoritmeanalyse
      |
      | of
      |
      em.term theory of algorithms
      |
      | genoemd.
      | Algoritmeanalyse richt zich op de voorspelbare
      |
      em.term groei
      |
      | van een algoritme zijn
      |
      em.term hulpbron/resource
      | -gebruik, die helemaal afhangt van de
      |
      em.term invoer
      |
      | (1. de
      em grootte
      |
      | en 2. de
      |
      em inhoud
      |
      | ervan).
    p
      | De grootte van de invoer druk je voor algoritmeanalyse uit met een positief natuurlijk getal \(n\).
      | Wat je verstaat onder ‘grootte’ hangt af van de manier waarop je algoritme werkt en wat voor type invoerdata het gebruikt.
      | Gewoonlijk staat het voor ‘het aantal elementen waaruit de invoerdata bestaat’, bijvoorbeeld elementenvan een lijst.
    component-section
      div(slot='title') Waarom je algoritmeanalyse leert
      p
        | We willen graag steeds grotere hoeveelheden data verwerken, want software is juist nuttig voor algoritmes die we als mensen zelf praktisch niet kunnen uitvoeren.
        span.praktijk
          | Als je een softwaresysteem meeontwikkelt dat véél data moet verwerken, is de
          |
          em.term schaalbaarheid
          |
          | van het ontwerp van het systeem erg belangrijk.
          | Algoritmeanalyse is bedoeld als hulpmiddel om juist schaalbaarheid van algoritmes en datastructuren te bepalen.
          | Door bedreven te zijn in algoritmeanalyse, speel je sneller een belangrijke rol binnen ontwikkelteams die zulke systemen ontwikkelen.
      p
        | Zelfs al doe je liever rechtstreekse metingen zonder verdere algoritmeanalyse, dan nog moet je de complexiteit van de algoritme-implementatie begrijpen, wil je de implementatie kunnen verbeteren naar aanleiding van je meting. 💡
        | Met andere woorden, met algoritmeanalyse kan je je metingen pas verklaren.
      p
        | Soms gééf je niet om het verder optimaliseren van een softwaresysteem dat een computationele taak oplost.
        | De algoritme-implementaties daarin hebben bijvoorbeeld naar jouw zin (als het goed is ook die van de gebruikers en
        | klanten) al een adequate looptijd.
        | Toch beïnvloedt de efficiëntie van de algoritme-implementaties het stroomverbruik van de hardware.
        | Bij populaire softwaresystemen, zoals WordPress, is het stroomverbruik zelfs aanzienlijk op wereldschaal. 🌳
        | Wil je het milieu sparen, en de batterij van je gebruikers, dan heeft het alsnog zin om efficiëntie te analyseren.
    component-section
      div(slot='title') De hulpbronnen: looptijd en geheugenruimte
      p
        | Een hulpbron kan in theorie van alles zijn, maar in de praktijk is het vaak
        |
        em.term tijd
        |
        | (looptijd) en
        |
        em.term ruimte
        |
        | (geheugen).
        | Net zoals een algoritme een
        |
        em.term tijdcomplexiteit
        |
        | heeft, heeft een algoritme geheugenruimte nodig om data te bewaren (
        em.term ruimtecomplexiteit
        | ).
        | In deze course sta je niet lang stil bij ruimtecomplexiteit.
        | Belangrijk is om te beseffen dat veel algoritmes ontworpen zijn met een afweging tussen gebruik van tijd en ruimte.
    p
      | Bij iedere algoritmeanalyse moet je nadenken over minstens drie onderdelen 🧩: geval, groeiorde en begrenzing.
      | In het volgende leer je over deze onderdelen, toegepast op tijdcomplexiteit.
    component-section
      div(slot='title') 🧩 A: Soort geval categoriseren met betrekking tot de invoerdata
      p
        | Eerst kies je van welk
        |
        em.term geval
        |
        | je uitgaat.
        | Met geval bedoel je dan
        |
        em niet
        |
        | de grootte van de invoerdata, maar juist de
        |
        em inhoud
        |
        | van de invoerdata. Want sommige algoritmes gaan zich heel anders gedragen als ze bepaalde data tegenkomen (dat zie je onder andere terug bij de sorteeralgoritmes straks).
        | Als de looptijd het allerhoogst is bij een bepaalde inhoud van de data, noemen we dat het
        em.term slechtste geval
        | .
        | Vice versa noemen het we
        |
        em.term beste geval
        | .
        | Tot slot neem je idealiter het
        |
        em.term gemiddelde geval
        | , maar dat zou je met ingewikkelde kansrekening en statistiek moeten bewijzen.
      p
        | Het
        |
        em slechtste
        |
        | geval is voor een software-ontwikkelaar op hbo-niveau het belangrijkst om te leren.
        | Door het slechtste geval te onderzoeken, weet je namelijk alvast zeker dat de bovengrens aan de looptijdgroei nooit slechter kan uitvallen op onvoorziene invoerdata.
        | Als je bijvoorbeeld data van buitenaf verwerkt weet je nooit zeker wat de inhoud daarvan is.
        span.praktijk
          | Onder andere vanwege beveiliging wil je dan weten of je softwaresysteem niet zal vastlopen vanwege een ongelukkig gekozen algoritme
        | .
      component-section
        div(slot='title') De zin van beste-geval-algoritmeanalyse
    component-section
      div(slot='title') 🧩 B: Groeisnelheid vereenvoudigen tot een groeiorde
      p
        | Stel, je weet de functie \(T(n)\) die de exacte looptijd geeft van het algoritme.
        | Aangenomen dat dit een stijgende functie is bij stijgende \(n\), ken je zo ook de groeisnelheid van de looptijd.
        | Soms groeit de looptijd niet, tenminste, niet afhankelijk van \(n\).
        | Dan noem je de looptijd van orde constant.
        | Linksom of rechtsom vereenvoudig je \(T(n)\) altijd tot een functie die alleen de
        |
        em.term groeiorde
        |
        | van de looptijd weergeeft.
        | Door die vereenvoudiging hoeft voor algoritmeanalyse iedereen uiteindelijk maar een handvol groeisnelheden te kennen.
        | Weet je de groeiorde, dan weet je dus net zo goed of/hoe snel de looptijd zal groeien als wanneer je \(T(n)\) weet.
        | Dus zelfs als je toch \(T(n)\) al weet, moet je die formule zo veel mogelijk vereenvoudigen tot een groeiorde.
      div#columns_groeiordes.columns
        table
          caption
            | Voorbeelden van groeiordes, op volgorde van niet-stijgend (constant), langzaam naar snel stijgend, naarmate \(n\) hoger is.
          thead
            tr
              th#element Groeiorde
              th#betekenis Naam
          tbody
            tr
              td \(1\)
              td Constant
            tr
              td \(\log (n)\)
              td Logaritmisch
            tr
              td \(n\)
              td Lineair
            tr
              td \(n \log (n)\)
              td Linearitmisch
            tr
              td \(n^2\)
              td Kwadratisch
            tr
              td \(n^3\)
              td Kubisch
            tr
              td \(n^{c}\)
              td Polynomiaal
            tr
              td \(c^{n}\)
              td Exponentieel
            tr
              td \(n!\)
              td Factoriaal
      p
        | Maar hoe leid je \(T(n)\) dan af, of hoe kan ik misschien op een andere manier de orde van groei bepalen van een algoritme?
        | Daarover later meer.
      component-section
        // TODO: Gebruik tijdens directe instructie
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297598/routing') De lijnen van de groeiordes (op Ans)
        component-exercise
    component-section
      div(slot='title') 🧩 C: Begrenzing aan groei aangeven
      p
        | Tot slot moet je nog aangeven hoe de groeiorde van het algoritme precies begrensd is.
      div#columns_begrenzingen.columns
        table#table_begrenzingen
          caption
            | Begrenzingen. Op de ⋅ schrijf je de groeiorde.
          thead
            tr
              th(scope='col') Begrenzing
              th(scope='col') Naam
              th(scope='col') Informele omschrijving
          tbody
            tr
              td.textalign_center \(o(⋅)\)
              td Kleine o
              td
                | Groeit langzamer dan
                span.nowrap \((&lt;)\)
            tr
              td.textalign_center \(O(⋅)\)
              td Grote o
              td
                | Groeit niet sneller dan
                span.nowrap \((≤)\)
            tr
              td.textalign_center \(Θ(⋅)\)
              td Grote theta
              td
                | Groeit zo snel als
                span.nowrap \((=)\)
            tr
              td.textalign_center \(Ω(⋅)\)
              td Grote omega
              td
                | Groeit niet langzamer dan
                span.nowrap \((≥)\)
            tr
              td.textalign_center \(ω(⋅)\)
              td Kleine omega
              td
                | Groeit sneller dan
                span.nowrap \((&gt;)\)
      // TODO: Grafiek toevoegen.
      p
        | \(O(⋅)\) wordt meestal voor het slechtste geval gebruikt.
        | Deze begrenzing is makkelijker te bepalen dan \(Θ(⋅)\) en \(o(⋅)\).
        | Ook is het zinniger om een bovengrens te weten dan een ondergrens (‘In het slechtste geval, groeit de looptijd
        |
        em minstens
        |
        | …’ 😑).
      p
        | Het geval kan je beperken in de begrenzingen die je
        |
        em kan
        |
        | geven.
        | Maar vice versa zegt de begrenzing strikt genomen niets over het geval waarover die gaat.
        | Neem bijvoorbeeld het volgende algoritme:
      figure
        figcaption
          | Dit algoritme heeft in het beste geval een looptijd van \(Θ(1)\) en in het slechtste geval van \(Ω(\log (n))\) en \(O(n)\).
          | Het is dus niet correct om te beweren dat dit algoritme een looptijd heeft van \(O(n)\), laat staan \(Θ(n)\).
          | Zulke beweringen zie je buiten deze course regelmatig.
          | Dan wordt eigenlijk bedoeld dat \(O(n)\) de ‘belangrijkste’ begrenzing is, en wel aan de looptijd is het slechtste geval.
        pre.lang-java.
      p
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297605/routing') Meerdere begrenzingen (op Ans)
        component-exercise
    component-section
      div(slot='title') Het resultaat van algoritmeanalyse rapporteren
      p
        | Nu heb je alle stukjes samen om het resultaat van je algoritmeanalyse te rapporteren:
      figure
        figcaption
          | Een voorbeeldbeschrijving van de uitkomst van een algoritmeanalyse.
          | Omkaderd staan de stukjes die afhangen van je algoritmeanalyse.
        p
          | Algoritme-implementatie \(\bbox[3px, border: 2px solid currentColor]{a}\) heeft
          |
          span.bbox in het slechtste geval
          |
          | een
          |
          span.bbox looptijd
          |
          | van \(\bbox[3px, border: 2px solid currentColor]{O}(\bbox[3px, border: 2px solid currentColor]{n})\)
          |
          small (zeg: ‘orde grote-o van n’, of ‘grote-o lineair’)
          | .
      p
        | Met deze bewering heb je het algoritme in een
        |
        em.term complexiteitscategorie
        |
        | geplaatst.
        | De groeiorde en de begrenzing samen, dus de notatie \(O(n)\), staat voor de
        |
        em verzameling
        |
        | van allerlei mogelijke functies \(T(n)\).
      figure
        figcaption
          | Formelere definitie van de bewering \(T(n) = O(⋅)\), met een willekeurige groeiorde \(f(n)\) op de \(⋅\).
          | Omkaderd staat een relatie \(≤\), die vind je terug in de informele omschrijving uit de
          a(href='#table_begrenzingen') Begrenzingentabel
          | .
        p
          | \(T(n) = O(f(n))\) is gedefinieerd als: ‘Er is ten minste één constante \(c &gt; 0\), en een andere constante
          | \(n_0 &gt; 0\), waarvoor \(0 ≤ T(n_0) \bbox[3px, border: 2px solid currentColor]{≤} c f(n_0)\) geldt, zolang \(n
          | ≥ n_0\).’.
      p
        | In de formele definitie betekent
        |
        q \(f(n)\)
        |
        | binnen
        |
        q \(O(f(n))\)
        |
        em niet
        |
        | de waarde van \(f\) met het argument \(n\), maar moet je
        |
        q \(f(n)\)
        |
        | opvatten als een
        |
        em aanduiding
        |
        | van de functie waarvan je de complexiteitscategorie uitdrukt.
        | Je had er ook alleen \(n\) kunnen zetten, maar dat is minder abstract en directer.
        | Dan zou \(f(n)=n^2≠n\) al niet meer passen in de definitie, bijvoorbeeld.
        | Verder, de \(=\) betekent niet zoals normaal ‘is gelijk aan’, maar ‘is orde’.
      p
        | Je kan hetzelfde algoritme ook in meerdere complexiteitscategorieën plaatsen natuurlijk, bijvoorbeeld een verschillende boven- en ondergrens of verschillende gevallen.
      p
        | In ADP word je alleen getoetst op je kennis van en vaardigheid met \(O(⋅)\), maar in de bronnen zie je de andere begrenzingen ook regelmatig terug.
        | Verder focus je in ADP op het analyseren van algoritmes met broncode en metingen in plaats van wiskundige analyse.
        | In het volgende leer je hoe je broncode analyseert.
    component-section
      div(slot='title') De groeiorde bepalen
      p
        | Uit het voorgaande leerde je de belangrijkste theoretische basis van algoritmeanalyse.
        | Wil je nu een concreet algoritme analyseren, dan moet je een groeiorde kunnen bepalen.
      component-section
        div(slot='title') Machinemodel
        p
          | Allereerst moet je weten hoe lang een computer doet over losse instructies.
          | Een
          |
          em.term machinemodel
          |
          | (
          em.term model of computation
          | ) is een vereenvoudigende aanname die je doet over de hardware, om een complexiteitsanalyse zo handig mogelijk uit te kunnen voeren.
          | Een machinemodel is een soort prijslijst: welke soorten instructies bestaan er, en hoeveel tijd kost elke?
          | In de praktijk hebben CPU’s veel grotere en ingewikkeldere instructiesets, maar deze zijn voor ons de belangrijkste:
        ol
          li lezen van een waarde
          li schrijven van een waarde
          li berekenen met één operator \(+,-,⨉,/\)
          li vergelijken van twee waardes
        p
          | Binnen algoritmeanalyse wordt het
          em.term Random Access Machine
          | -machinemodel aangenomen.
          | Je hoeft in de praktijk echt niet te gaan tellen welke instructies er precies gebruikt worden tegen welke prijs.
          | Het belangrijkste is de aanname dat ze allemaal grofweg dezelfde looptijd kosten en dus weggestreept mogen worden als de hoeveelheid instructies verder onafhankelijk is van \(n\).
        p
          | In het volgende leer je enkele regels waarmee je een \(T(n)\) moet vereenvoudigen tot een groeiorde.
      component-section
        div(slot='title') Verwaarloos constanten
        p
          | Verder, naarmate \(n\) groter is, worden veel details van \(T(n)\) steeds minder belangrijk.
          | Er zijn simpele regels die je moet toepassen om de groei te vereenvoudigen tot een groeiorde.
        p
          | Zelfs als je heel veel instructies hebt in je algoritme-implementatie, moet je die
          |
          em negeren voor zover ze niet afhangen van \(n\)
          | .
          | Stel, de hardware moet bij bepaalde algoritme-implementatie áltijd maar liefst \(182 323\) keer een som maken, en daarna \(n\) keer één meer andere instructies.
          | Dan mag je de grote constante \(182 323\) niet meetellen, want die valt in het niet bij \(n\), doordat je in algoritmeanalyse ervan uitgaat dat \(n\) onbeperkt groot mag zijn.
        div#columns_verwaarloosconstanten.columns
          table
            caption
              | Voorbeelden van hoe constanten verwaarloosd moeten worden.
            thead
              tr
                th#constanten_T \(\boldsymbol{T(n)}\)
                th#constanten_groeiorde Groeiorde
            tbody
              tr
                td \(182 323 + n\)
                td \(n\)
              tr
                td \(50n\)
                td \(n\)
              tr
                td \(n^2+50^5\)
                td \(n^2\)
              tr
                td \(300n^2\)
                td \(n^2\)
              tr
                td \(n^3×100\)
                td \(n^3\)
              tr
                td \(\frac{n^3}{100}\)
                td \(n^3\)
              tr
                td \(\frac{100}{n^3}\)
                td
                  | \(\frac{1}{n^3}\), om dalende groeiorde te behouden.
                  | (Dit is een zuiver theoretisch voorbeeld.)
              tr
                td \(42n^3+10000\)
                td \(n^3\)
              tr
                td \(\log^{10}(n)\)
                td \(\log(n)\)
              tr
                td \(\log^2(n)\)
                td \(\log (n)\)
              tr
                td \(2^n\)
                td
                  | \(2^n\), constanten in het grondtal van een macht met een variabele in de exponent mag je niet verwaarlozen.
              tr
                td \(n^{2+1}\)
                td
                  | \(n^3\), constanten in de exponent van een macht met een variabele in het grondtal mag je niet verwaarlozen.
              tr
                td \(n \log (n^2)\)
                td
                  p \(\log^a\left(x^b\right) = b⋅\log^a\left(x \right)\), als \(x ≥ 0\)
                  p
                    | \(2n \log (n)\) wordt \(n \log (n)\).
                    | Dit is dus een uitzondering op de machtenregel.
        p
          | Zoals je in de voorgaande tabel ziet, zijn er wel beperkingen aan het verwaarlozen van constanten.
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297612/routing') Begrip grote-o - Grote constanten en algoritmeanalyse (op Ans)
        component-exercise
      component-section
        div(slot='title') Verwaarloos kleinere termen
        p
          | Oftewel, vereenvoudig tot de dominante
          |
          em.term term
          | .
          | Een term is een deel van de formule gescheiden door optellen of aftrekken.
          | Als er meerdere gelijke termen zijn, blijft er één over.
        div#columns_verwaarlooskleineretermen.columns
          table
            caption
              | Voorbeelden van hoe kleinere termen verwaarloosd en ingewikkelde formules vereenvoudigd moeten worden.
            thead
              tr
                th#kleinetermen_T \(\boldsymbol{T(n)}\)
                th#kleinetermen_groeiorde Groeiorde
            tbody
              tr
                td \(50n^3+2n^2+25\)
                td \(n^3\)
              tr
                td \(10n × 12n\)
                td \(n^2\)
              tr
                td \(\frac{50n^3}{2n^2}\)
                td \(n\), eerst de breuk vereenvoudigen.
              tr
                td \(0.5 n \log(n) - 2n + 7\)
                td
                  p \(n \log(n)\)
                  p
                    a(href='https://www.geogebra.org/calculator/qxmvq3sx') De linkerterm groeit sneller
                    | .
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297623/routing') Begrip grote-o - Meerdere gelijke termen (op Ans)
        component-exercise
    component-section
      div(slot='title') De groeiorde bepalen met broncode
      p
        | Nu je de basiskennis hebt van algoritmeanalyse, leer je hoe je algoritmeanalyse
        |
        em doet
        |
        | op een algoritme-implementatie (in broncode dus).
        | Je ziet telkens een broncodefragment dat uit een algoritme zou kunnen komen, en vervolgens uitleg hoe je het fragment kan analyseren.
      figure
        figcaption Een lus, afhankelijk van \(m\).
        pre.
      p
        | De lus wordt een aantal keer doorlopen, afhankelijk van de invoergrootte, dus heeft een looptijd van \(Θ(m)\)
        | (met andere woorden, is van orde lineair), in alle gevallen.
      p
        | Gangbaar is om er gewoon \(n\) (dus hier \(Θ(n)\)) van te maken, want de enkele parameternaam
        |
        code m
        |
        | betekent bij dit algoritme verder niets interessants.
        | In de broncode hoeft in ieder geval, net als in de groeiorde géén letterlijke
        |
        code n
        |
        | als (functie)parameter of variabele te bestaan met als waarde de invoergrootte, om algoritmeanalyse te kunnen doen.
      figure
        figcaption Een lus, afhankelijk van \(m\).
        pre.
      p
        | Een nesting van lussen afhankelijk van \(n\) is vaak een aanwijzing voor \(T(n) = n^d …\), waarbij \(d\) de
        | diepte van de nesting is.
        | In dit voorbeeld is \(T(n) = m × m …\).
        | De voorgaande broncode heeft dan ook een looptijd van \(Θ(n^2)\), in alle gevallen.
      p
        | Maar blijf wel opletten, want het is mogelijk geneste lussen te hebben afhankelijk van \(n\), maar eigenlijk nog een lineair aantal iteraties.
      figure
        figcaption Een lus, afhankelijk van \(m\).
        pre.
      p
        | De voorgaande broncode heeft dan weer een looptijd van \(Θ(n)\), in alle gevallen.
      figure
        figcaption Eén lus, maar kwadratisch aantal iteraties.
        pre(data-line='1').
      p
        | En in de voorgaande broncode is er maar één lus.
        | Toch is de looptijd niet van orde lineair.
        | Deze broncode heeft een looptijd van \(Θ(n^2)\), in alle gevallen.
      figure
        figcaption
          | Lus met
          |
          code.lang-java if
          | .
        pre.lang-java.
      p
        | De voorgaande lus wordt ondanks de
        |
        code.lang-java if
        |
        | nog steeds een aantal keer doorlopen afhankelijk van de invoergrootte.
        | De instructies door de
        |
        code.lang-java if
        |
        | hebben een looptijd onafhankelijk van \(n\).
      p De voorgaande broncode heeft dus een looptijd van \(Θ(n)\), in alle gevallen.
      p
        | De invoergrootte mag in de broncode zelfs ongebonden aan een variabelenaam zijn, met als alternatief bijvoorbeeld via de vaak beschikbare
        |
        code length
        | -eigenschap.
      figure
        figcaption Een lus die vroeg kan stoppen.
        pre#code_earlyreturn.language-java(data-line='4').
      p
        | De lus wordt een aantal keer doorlopen, afhankelijk van de invoergrootte.
        | Dat aantal is in het slechtste geval \(n\).
        | De looptijd van de lus is dus \(Θ(n)\) in het slechtste geval.
        | Tevens is de lus \(Θ(1)\) in het beste geval, namelijk als het eerste element gelijk is aan
        |
        code.lang-java item
        | .
        | Dat komt door de
        a(href='#code_earlyreturn.4')
          | de vroege
          |
          code.lang-java return
        | .
        | En je mag, simpelweg, ook beweren dat de looptijd van de lus \(O(n)\) is in alle gevallen, omdat \(O(n)\) alleen een lineaire
        |
        em bovengrens
        |
        | aangeeft.
      figure
        figcaption Een constant kleinere lus.
        pre.
      p
        | De lus wordt de helft van \(n\) keer doorlopen afhankelijk van de invoergrootte.
        | Dat is nog steeds ‘een aantal keer onafhankelijk van \(n\)’, want de coëfficiënt \(0.5\) is maar een constante.
        | Dus deze lus heeft een looptijd van \(Θ(n)\), in alle gevallen.
      p
        | Je herkent algoritmes met een logaritmische tijdcomplexiteit aan dat de data voor het probleem steeds verder gehalveerd wordt.
        | Dat heet het
        |
        em.term repeating halving/doubling principle
        | : als in constante tijd telkens, afhankelijk van \(n\), het aantal te verwerken elementen wordt gehalveerd, dan heeft dat deel van het algoritme een groeiorde \(log ⁡n\).
      figure
        figcaption Het repeating halving principe.
        pre#code_repeatinghalving(data-line='1').
      p
        | Doordat de index
        |
        code.lang-java i
        |
        | in het voorgaande broncodefragment
        a(href='#code_repeatinghalving.1')
          | steeds sneller stijgt afhankelijk van
          |
          code.lang-java n
        | , waardoor het aantal benodigde iteraties steeds sneller afneemt (halveert), heeft de buitenste lus een looptijd van \(Θ(\log ⁡n)\), in alle gevallen.
        | De geneste lus heeft een looptijd van \(Θ(n)\), in alle gevallen.
        | Dus het hele broncodefragment heeft een looptijd van \(Θ(n \log ⁡n)\), in alle gevallen.
      component-section
        div(slot='title') Opeenvolgende stukken hebben de maximale groeiorde
        p
          | Als je opeenvolgende op zichzelf staande stukken binnen dezelfde scope van de broncode van een algoritme-implementatie apart zou analyseren, kan je op twee complexiteitscategorieën uitkomen.
          | Het algoritme als geheel heeft namelijk de maximale groeiorde van alle losse stukken.
          | Als ze beide dezelfde groeiorde hebben, dan vereenvoudig je nog steeds tot één groeiorde.
        p
          | Wiskundig gezien zou je de complexiteitscategorieën van de delen moeten optellen om de complexiteitscategorie van het hele algoritme te weten.
          | En dan geldt onder andere weer de regel van de dominante term.
        p
          | Gegeven algoritmes \(a(n)\), \(b(n)\), geldt \(T_a(n) + T_b(n) = O(\max(a(n), b(n)))\)
        p
          | Dus stel \(a = O(f(n))\) en \(b = O(f(n))\), dan \(O(a) + O(b) = O(a+b) = O(f(n))\).
        p En, bijvoorbeeld \(O(n^2) + O(n) = O(n^2)\).
    component-section
      div(slot='title') De groeiorde bepalen: een visuele, toegepaste uitleg
      p
        | Je hebt nu veel informatie verwerkt.
        | ’t Beste leer je algoritmeanalyse met \(O(⋅)\) door vaak naar voorbeelden te kijken.
        | In de volgende video’s legt Kevin Drumm algoritmeanalyse met \(O(⋅)\) uit ondersteund met visualisaties.
        | ⚠️ Drumm gebruikt daarbij enkele voorbeelden van algoritmes en datastructuren die je later pas grondig leert.
        | Vat de voorbeelden voor nu op als illustraties.
      p.bron Big O Part 1 - Linear Complexity
      component-video(videoid='OMInLBKYAWg', title='Big O Part 1 - Linear Complexity')
      p.bron Big O Part 2 - Constant Complexity
      component-video(videoid='1Md4Uo8LtHI', title='Big O Part 2 - Constant Complexity')
      p.bron Big O Part 3 - Quadratic Complexity
      component-video(videoid='mIjuDg8ky4U', title='Big O Part 3 - Quadratic Complexity')
      p.bron Big O Part 4 - Logarithmic Complexity
      component-video(videoid='Hatl0qrT0bI', title='Big O Part 4 - Logarithmic Complexity')
      p.bron Big O Part 5 – Linearithmic Complexity
      component-video(videoid='i7CmolBf3HM', title='Big O Part 5 – Linearithmic Complexity')
      p.bron Big O Part 6 – Summary of Time Complexities
      component-video(videoid='XiGedDZGOM8', title='Big O Part 6 – Summary of Time Complexities')
      p.bron Big O Part 7 – Space Complexity versus Time Complexity
      component-video(videoid='bNjMFtHLioA', title='Big O Part 7 – Space Complexity versus Time Complexity')
      p
        | Algoritmeanalyse is niet per se zinvol voor ieder algoritme.
        | Als het algoritme niet gebruikt wordt voor grote hoeveelheden data, is algoritmeanalyse niet zinvol.
      p.bron
        a(href='https://lemire.me/blog/2013/07/11/big-o-notation-and-real-world-performance/') Big-O notation and real-world performance
    component-section(extra='')
      div(slot='title') Betere manieren om algoritmes te analyseren
      p
        | Een moeilijkere maar krachtigere methode dan algoritmeanalyse is het wiskundig bewijzen hoeveel van welke soorten instructies er precies uitgevoerd worden, gegeven strikt realistische invoerdata (bijvoorbeeld het gemiddelde geval) en een machinemodel.
        | Zo kan je een veel nauwkeurigere \(T(n)\) van een algoritme berekenen.
        | Met zo’n model kan je algoritmes ook, zonder meting, vergelijken tussen hardware.
        | Je leert dit niet in deze course, maar je kan hierover meer lezen in aanvullende bronnen
        cite(data-id='6867189/EW26IVKM')
        | .
  component-section
    div(slot='title') De complexiteitscategorieeën van operaties
    p
      | Operaties hebben elk hun eigen complexiteitscategorie.
      | Welke complexiteitscategorie hangt weliswaar af van de implementatiedetails, maar het is al wel bekend wat de optimale complexiteitscategorieën zijn van de operaties van standaard-adt’s.
      | Met deze kennis weet je voor wélke toepassing en context je ontwikkelteam het beste voor wélke datastructuur kan kiezen.
    component-section
      div(slot='title') Wanneer je arrays dan wel linked lists gebruikt
      p.bron Linked Lists and Dynamic Arrays: Misuse and Abuse
      component-video(videoid='K8H4LGWB5vQ', title='Linked Lists and Dynamic Arrays: Misuse and Abuse')
      p.instructor_only
        | Een element verwijderen uit een dynamische rij heeft een looptijd van \(Θ(n)\) in het gemiddelde geval.
        | Maar Taylor heeft het over verwijderen van ‘every other item’ (elementen om-en-om), ca. \(\frac{n}{2}\) elementen.
        | Dus \(Θ(n \frac{n}{2}) = Θ(n^2)\).
        | De uitspraak van Taylor is dus wat vergezocht, maar is bedoeld als een speciaal voorbeeld waarin een linked list een betere complexiteitscategorie geeft dan een
        |
        code.lang-java ArrayList
        | .
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297630/routing')
            code List
            | -interface missers (op Ans)
        component-exercise
    p
      | Later in ADP leer je over een relatief optimale implementatie en een belangrijke toepassing van de prioriteitswachtrij.
      | Het is ook mogelijk om de prioriteitswachtrij te implementeren op een naïeve manier, door intern bijvoorbeeld een lijst bij te houden en die telkens te sorteren op prioriteit.
